## R-1.4.1.tgz

=== src/gnuwin32/Makefile ===
include MkRules
include RWVERSION

all: rbuild rpackage rdocs

## configuration macros
HELP = YES
WINHELP = CHM# NO, CHM, BOTH

LEA_MALLOC=YES

# Set to YES and specify the path if you want to use the ATLAS BLAS.
USE_ATLAS=NO
ATLAS_PATH=/R/ATLAS/lib/WinNT_PII

PACKAGES = base ctest eda lqs methods modreg mva nls splines stepfun tools ts
ALLPACKAGES = $(PACKAGES) tcltk

RHOME = $(shell perl pwd.pl ../..)# must be absolute path
RLIB = $(RHOME)/library
PKGDIR = $(RHOME)/src/library
PKGD = $(shell perl pwd.pl $(PKGDIR))# must be absolute path

OPTFLAGS=-O2 -Wall -pedantic
## use FOPTFLAGS where complex*16 is used.
FOPTFLAGS=-O2 -Wall
ifdef DEBUG
 OPTFLAGS+=-g
 FOPTFLAGS+=-g
 DLLFLAGS=
else
 DLLFLAGS=-s
endif

R-DLLFLAGS = -mwindows
R-DLLLIBS =-L. $(FLIBS) -lcomctl32 -lversion
ifeq ($(strip $(USE_ATLAS)),YES)
FLIBS +=-L$(ATLAS_PATH) -lcblas -lf77blas -latlas
endif
SOURCES = $(filter-out malloc.c,$(wildcard *.c *.f))
OBJS = $(SOURCES:.c=.o)
MAINLIBS = libmain.a libappl.a libmath.a
EXTRALIBS = ga.a gl.a xdr.a em.a bitmap/zlib/libz.a

LIBFILES = $(foreach i, $(ALLPACKAGES), ../../library/$i) ../../library/R.css
PKGS = $(foreach i,$(PACKAGES),pkg-$i)
PKGCLEAN = $(foreach i,$(ALLPACKAGES),pkgclean-$i)

# flags to ensure that Doug Lea's malloc is used:
ifdef LEA_MALLOC
extra-CFLAGS+=-DLEA_MALLOC
OBJS-EXTRA=malloc.o
endif

.PHONY:  clean veryclean  rlibs fixfiles front-ends rmodules


# separate as Tcl/Tk headers are needed.
tcl: 
	$(MAKE) STAMP=NO pkg-tcltk

CFLAGS = $(OPTFLAGS) -I../include -I. -DHAVE_CONFIG_H -DR_DLL_BUILD
FFLAGS = $(OPTFLAGS)

rbuild: fixfiles rlibs makeMakedeps ../../bin/R.dll libR.a \
	 CHTML front-ends COPYRIGHTS rmodules

rpackage: fixed/fixdesc ../../library/R.css
	$(MAKE) STAMP=NO $(PKGS)

rinstaller:
	$(MAKE) -C installer RPREFIX=$(RPREFIX)

rlibs:
	$(MAKE) -C ../appl  OPTFLAGS='$(OPTFLAGS)' USE_ATLAS=$(USE_ATLAS) -f Makefile.win
	$(MAKE) -C ../main  OPTFLAGS='$(OPTFLAGS)' -f Makefile.win
	$(MAKE) -C ../nmath OPTFLAGS='$(OPTFLAGS)' -f Makefile.win
	$(MAKE) -C ./graphapp
	$(MAKE) -C ./getline
	$(MAKE) -C ../extra/xdr
	$(MAKE) -C ./math

rmodules: libRm.a
	$(MAKE) -C ../modules OPTFLAGS='$(OPTFLAGS)' FOPTFLAGS='$(FOPTFLAGS)' \
	  USE_ATLAS=$(USE_ATLAS) ATLAS_PATH=$(ATLAS_PATH) -f Makefile.win

COPYRIGHTS: $(RHOME)/COPYRIGHTS COPYRIGHTS.win
	cat $^ > $@


fixfiles:
	$(MKDIR) -p ../../bin
	$(MAKE) -C ./fixed
	$(CP) -pr unzip ../..
	$(RM) ../../unzip/*.h

fixed/fixdesc:
	sh fixed/GETDESC $(ALLPACKAGES)

dllversion.o: ../include/Rversion.h

R.dll: R.a $(OBJS-EXTRA) $(MAINLIBS) $(EXTRALIBS) dllversion.o

Rdll: makeMakedeps ../../bin/R.dll

../../bin/R.dll: fixfiles rlibs R.dll
	$(MKDIR) -p ../../bin
	$(CP) R.dll ../../bin/

front-ends: libRm.a
	$(MAKE) -C front-ends

R.a: $(OBJS)
	@$(ECHO) -------- Building $@ --------
	$(AR) cr R.a $^
	$(RANLIB) R.a


# R.dll exports all global symbols BUT import library (libR.a)
# only (all functions) + (global vars listed in exported-vars))

libR.a:  R.exp
	$(DLLTOOL) $(DLLTOOLFLAGS) $(R-DLLTOOLFLAGS) --dllname R.dll --def R.exp --output-lib libR.a

R.exp: R.exp1
	(diff R.exp R.exp1 > /dev/null) || $(CP) R.exp1 R.exp

R.exp1: R.a $(MAINLIBS) $(EXTRALIBS) exported-vars
	$(ECHO) EXPORTS > $@
	$(NM) R.a $(MAINLIBS) $(EXTRALIBS) > RDefs
	$(SED) -n '/^........ [T] _/s/^........ [T] _/ /p' RDefs >> $@
	$(CAT) exported-vars >> $@
	$(RM) RDefs

# A version needed for the modules that uses R.dll's malloc/.../free

libRm.a:  Rm.exp
	$(DLLTOOL) $(DLLTOOLFLAGS) $(R-DLLTOOLFLAGS) --dllname R.dll --def Rm.exp --output-lib libRm.a

Rm.exp: Rm.exp1
	(diff Rm.exp Rm.exp1 > /dev/null) || $(CP) Rm.exp1 Rm.exp

Rm.exp1: R.a $(OBJS-EXTRA) $(MAINLIBS) $(EXTRALIBS) exported-vars
	$(ECHO) EXPORTS > $@
	$(NM) R.a $(OBJS-EXTRA) $(MAINLIBS) $(EXTRALIBS) > RDefs
	$(SED) -n '/^........ [T] _/s/^........ [T] _/ /p' RDefs >> $@
	$(CAT) exported-vars >> $@
	$(RM) RDefs

../../library/R.css: ../../doc/html/R.css
	$(CP) $< $@

bitmap/zlib/libz.a:
	$(MAKE) -C bitmap buildzlib

rdocs:
	@$(MAKE) -C ../../doc/manual -f Makefile.win html


#                          ===== Packages ======

CHTML:
ifeq ($(strip $(HELP)),YES)
ifeq ($(strip $(WINHELP)),CHM)
	$(MAKE) -C ./help -f MkChmDll
endif
ifeq ($(strip $(WINHELP)),BOTH)
	$(MAKE) -C ./help -f MkChmDll
endif
endif

base-HELP = ziponly
nls-HELP = ziponly
ts-HELP = ziponly
base-ZIPDATA = zip
ts-ZIPDATA = zip

MASS-HELP = ziponly
MASS-ZIPDATA = zip

bundle-%:
	$(PERL) fixed/dobundle.pl $* $(PKGD) $(RLIB)

pkg-%:
	$(MAKE) DLLNM=$($*-DLLNM)  FLIBS="$(FLIBS)" \
	  -C $(PKGDIR)/$* PKG=$* RHOME=$(RHOME) RLIB=$(RLIB) \
	  -f $(RHOME)/src/gnuwin32/MakePkg
	@if test -d $(RLIB)/$*/data ; then \
	  $(MAKE) $($*-ZIPDATA)data-$* ; \
	fi
ifeq ($(strip $(HELP)),YES)
	$(MAKE) -C ./help RHOME=$(RHOME) PKGDIR=$(PKGD) RLIB=$(RLIB) $($*-HELP)help-$*
	$(MAKE) -C ./help RHOME=$(RHOME) PKGDIR=$(PKGD) RLIB=$(RLIB) contents-$*
ifeq ($(strip $(WINHELP)),CHM)
	$(MAKE) -C ./help RHOME=$(RHOME) PKGDIR=$(PKGD) RLIB=$(RLIB) chm-$*
endif
ifeq ($(strip $(WINHELP)),BOTH)
	$(MAKE) -C ./help RHOME=$(RHOME) PKGDIR=$(PKGD) RLIB=$(RLIB) winhlp-$* # also makes chm
endif
endif

pkgclean-%:
	$(MAKE) DLLNM=$($*-DLLNM) RHOME=$(RHOME) \
	  -C $(PKGDIR)/$* PKG=$* -f $(RHOME)/src/gnuwin32/MakePkg clean

pkgcheck-%:
	@$(ECHO) -------- Testing package $* --------
	-@mkdir -p $(PKGDIR)/$*/check
	@$(MAKE) -C $(PKGDIR)/$*/check PKG=$* RHOME=$(RHOME) RLIB=$(RLIB) \
	  -f $(RHOME)/src/gnuwin32/check/PkgCheck
	@if test -d $(PKGDIR)/$*/tests ; then \
	  $(MAKE) -C $(PKGDIR)/$*/tests PKG=$* RHOME=$(RHOME) RLIB=$(RLIB) \
	    -f $(RHOME)/src/gnuwin32/check/PkgCheck tests;\
	fi

ziphelp-%:
	$(MAKE) -C ./help RHOME=$(RHOME) PKGDIR=$(PKGD) RLIB=$(RLIB) ziphelp-$*

ziponly-%:
	$(MAKE) -C ./help RHOME=$(RHOME) PKGDIR=$(PKGD) RLIB=$(RLIB) ziponlyhelp-$*

zipdata-%:
	@echo "  zipping data"
	@(cd $(RLIB)/$*/data; \
	  if test -f Rdata.zip ; then \
	    unzip -qou Rdata; \
	  fi; \
	  $(RM) Rdata.zip filelist ; \
	  ls -1 > filelist; \
	  zip -rmq9X Rdata * -x filelist 00Index)

data-%:
	@echo "  not zipping data"


#                          ===== cleaning ======

clean: cleanwin $(PKGCLEAN)
	$(RM) -f ../*/*.o $(WINOBJS) *.a ../*/*.d ../*/Makedeps fixed/fixdesc
	-$(MAKE) -C ../../doc/manual -f Makefile.win distclean
	-$(MAKE) -C ../nmath/standalone -f Makefile.win distclean
	-$(MAKE) -C ../modules -f Makefile.win clean
	-$(MAKE) -C ../../tests -f Makefile.win clean
	$(RM) -f ../library/methods/R/methods

distclean veryclean: clean
	$(RM) COPYRIGHTS R.exp Rm.exp 
	$(RM) -r ../../bin ../../library ../../modules
	$(RM) ../include/config.h ../include/psignal.h \
	../include/Rconfig.h ../include/version.h 
	$(RM) ../library/*/src/*.o ../library/*/src/*.a
	$(RM) ../library/*/src/*.dll
	$(RM) -r ../library/*/check
	$(RM) ../../doc/html/search/index.txt ../../doc/html/index.html \
	../../doc/html/packages.html ../../doc/html/rwin.html \
	../../doc/html/rw-FAQ.html ../../doc/html/search/SearchEngine.html
	$(RM) ../../etc/Rconsole ../../etc/Rdevga ../../etc/Rprofile \
	../../etc/rgb.txt ../../share/make/tests.mk \
	../include/Platform.h ../../tests/*.Rout ../../tests/*.Rout.fail
	$(MAKE) -C fixed distclean
	-$(MAKE) -C installer ISdistclean
	@for pkg in $(ALLPACKAGES); do \
	  $(RM) ../library/$${pkg}/DESCRIPTION; \
	done

cleanwin:
	$(RM) *.o *.exe *.dll *.a *~ \#*\# rw*.zip R.def R.exp1 Rm.exp1\
	   .RData .Rhistory Makedeps *.d
	$(MAKE) -C graphapp clean
	$(MAKE) -C fixed clean
	$(MAKE) -C getline clean
	$(MAKE) -C help clean
	$(MAKE) -C front-ends clean
	$(MAKE) -C ../extra/xdr clean
	$(MAKE) -C math clean
	$(MAKE) -C bitmap clean
	-$(MAKE) -C installer clean ISclean


#                          ===== testing ======

# tests
check test: test-Specific pkgtests

test-Specific:
	-@$(MAKE) -C $(RHOME)/tests -f $(RHOME)/tests/Makefile.win clean
	-@$(MAKE) -C $(RHOME)/tests -f $(RHOME)/tests/Makefile.win RHOME=$(RHOME)


PKGS-CHK = $(foreach i, $(PACKAGES), pkgcheck-$i)
pkgtests: $(PKGS-CHK)


#                          ===== documentation ======

docs manuals:
	@$(MAKE) -C $(RHOME)/doc/manual -f Makefile.win clean BUILD=$(BUILD)
	@$(MAKE) -C $(RHOME)/doc/manual -f Makefile.win \
	  R_PKGS='$(ALLPACKAGES)' BUILD=$(BUILD)
	@$(MAKE) ziponly-base


## ===================== Maintainer targets ========================

RVER = $(shell cut -d' ' -f1 ../../VERSION | sed -n 1p)

docfiles: INSTALL FAQs
SEDVER = -e s/@RVER@/$(RVER)/g -e s/@RWVER@/$(RPREFIX)/g

INSTALL: INSTALL.in ../../VERSION RWVERSION
	$(SED) $(SEDVER) INSTALL.in > INSTALL

FAQs: rw-faq fixed/html/rw-FAQ.html

fixed/html/rw-FAQ.html: rw-FAQ.texi ../../VERSION RWVERSION
	@$(SED) $(SEDVER) $< > tmp.texi
	makeinfo --no-split --html --no-headers --number-sections -o tmp.html tmp.texi
	-tidy tmp.html > $@ 2> /dev/null
	@$(RM) tmp.texi tmp.html

rw-faq: rw-FAQ.texi ../../VERSION RWVERSION
	$(SED) $(SEDVER) $< | \
	  makeinfo --no-headers --number-sections -o $@

bitmapdll:
	$(MAKE) -C bitmap

distribution: bindist packagedist docsdist

bindist: tcl bitmapdll docfiles
	$(RM) -r $(RPREFIX)
	$(MKDIR) $(RPREFIX)
	$(CP) -pr ../../bin ../../modules ../../afm ../../unzip $(RPREFIX)
	$(MKDIR) $(RPREFIX)/library
	$(CP) -pr $(LIBFILES) $(RPREFIX)/library
# morley.tab is needed for R-intro Appendix A
	$(CP) -p ../library/base/data/morley.tab $(RPREFIX)/library/base/data
	$(RM) $(RPREFIX)/*/Makefile.in
	(cd $(RPREFIX)/bin; $(RM) Rcmd.exe INSTALL REMOVE SHLIB build check \
	   massage-Examples Rd2dvi.sh Rd2txt Rdconv Rdiff.sh Rdindex \
           Sd2Rd Rprof)
	$(MKDIR) $(RPREFIX)/etc
	$(CP) -p ../../etc/Rprofile $(RPREFIX)/etc/Rprofile
	$(CP) -p ../../etc/Rconsole $(RPREFIX)/etc/Rconsole
	$(CP) -p ../../etc/Rdevga $(RPREFIX)/etc/Rdevga
	$(CP) -p ../../etc/rgb.txt $(RPREFIX)/etc/rgb.txt
	$(MKDIR) -p $(RPREFIX)/doc/manual  $(RPREFIX)/share/texmf
	$(CP) -pr ../../doc/html $(RPREFIX)/doc
	$(CP) -p ../../doc/manual/*.html $(RPREFIX)/doc/manual
	$(CP) -pr ../../share/texmf $(RPREFIX)/share
	$(CP) -p ../../AUTHORS ../../COPYING COPYRIGHTS ../../FAQ ../../NEWS \
		../../THANKS ../../Y2K $(RPREFIX)
	$(SED) -e s/@RWVER@/$(RPREFIX)/g \
	  -e s/@RVER@/$(RVER)/g readme > $(RPREFIX)/README
	$(CP) -p rw-faq $(RPREFIX)/rw-FAQ
	$(CP) -p CHANGES README.Rterm $(RPREFIX)
	-find $(RPREFIX) -name CVS -exec rm -rf \{\} \;
# convert docs and batch files to CRLF: might already be on Windows, though.
ifeq ($(strip $(BUILD)),CROSS)
	zip -l dosfiles.zip $(RPREFIX)/* $(RPREFIX)/bin/*.bat
	unzip -ao dosfiles.zip
else
	zip dosfiles.zip $(RPREFIX)/* $(RPREFIX)/bin/*.bat
	unzip -o dosfiles.zip
endif
	$(RM) dosfiles.zip
	$(RM) $(RPREFIX)b.zip $(RPREFIX)m.zip $(RPREFIX)h.zip \
	   $(RPREFIX)w.zip $(RPREFIX)l.zip $(RPREFIX)ch.zip
	$(RM) anindex.zip
	zip -mrX anindex.zip $(RPREFIX)/library/*/help/AnIndex
	zip -mr9X $(RPREFIX)h.zip $(RPREFIX)/library/*/help
	unzip anindex.zip
	$(RM) anindex.zip
	$(RM) $(RPREFIX)/doc/manual/R-FAQ.html
	zip -rm9X $(RPREFIX)w.zip $(RPREFIX)/doc/html \
          $(RPREFIX)/doc/manual/*.html \
	  $(RPREFIX)/library/*/html $(RPREFIX)/library/R.css
	-zip -rm9X $(RPREFIX)ch.zip $(RPREFIX)/library/*/chtml \
	  $(RPREFIX)/bin/Rchtml.dll
#	$(RM) $(RPREFIX)/library/*/winhlp/*.GID
#	-zip -rm9X $(RPREFIX)wh.zip $(RPREFIX)/library/*/winhlp
	zip -rm9X $(RPREFIX)l.zip $(RPREFIX)/library/*/latex $(RPREFIX)/share/texmf
	$(RM) -r $(RPREFIX)/doc
	mkdir -p  $(RPREFIX)/doc/html
	$(CP) -p ../../doc/html/faq.html ../../doc/html/rw-FAQ.html \
	  $(RPREFIX)/doc/html
	zip -rm9X $(RPREFIX)m.zip $(RPREFIX)/library/*/man
	zip -r9X $(RPREFIX)b.zip $(RPREFIX)
	$(RM) -rf $(RPREFIX)


#taken from ../include/Makefile.in
SRC_HEADERS = R.h S.h Rdefines.h Rgraphics.h Rinternals.h Rmath.h
OBJ_HEADERS = Rconfig.h Rversion.h
GW32_HEADERS =

packagedist:
	$(RM) -r $(RPREFIX)sp.zip $(RPREFIX)
	$(MKDIR) -p $(RPREFIX) $(RPREFIX)/bin $(RPREFIX)/etc \
	  $(RPREFIX)/doc $(RPREFIX)/doc/html $(RPREFIX)/share \
	  $(RPREFIX)/src/include $(RPREFIX)/src/library \
	  $(RPREFIX)/src/gnuwin32/fixed
	$(CP) ../../doc/html/logo.jpg $(RPREFIX)/doc/html
	$(CP) ../../doc/KEYWORDS* $(RPREFIX)/doc

=== src/extra/xdr/Makefile ===
include ../../gnuwin32/MkRules

CFLAGS=-O2 -I. -DWIN32 -D_X86_

../../gnuwin32/xdr.a: xdr.o xdr_float.o xdr_stdio.o xdr_mem.o

clean:
	$(RM) *.o *~

=== debian/control ===
Source: r-base
Section: math
Priority: optional
Maintainer: Dirk Eddelbuettel <edd@debian.org>
Standards-Version: 3.5.0
Build-Depends: blas-dev (>= 1.0-9), libgnome-dev, libzvt-dev, libgtkxmhtml-dev, tcl8.3-dev, tk8.3-dev, libglade-gnome0-dev, bison, g77 [!m68k !ia64], g77-3.0 [ia64], f2c [m68k], gcc-3.0 [ia64], g++-3.0 [ia64], groff-base, libncurses5-dev, libreadline4-dev, tetex-bin, tetex-extra, debhelper (>= 3.0.0)

Package: r-base
Architecture: any
Depends: ${perl:Depends}, zlib-bin, ${shlibs:Depends}
Conflicts: r-cran
Suggests: g77, libpaperg, ess, r-recommended
Description: `GNU S' - A language and environment for statistical computing.
 R is described by its authors as "not unlike" S, which is a language
 developed at Bell Laboratories for statistical computing and graphics.
 It provides support for a variety of statistical and graphical analyses.
 R is a true computer language which contains a number of control-flow
 constructions for iteration and alternation.  It allows users to add
 additional functionality by defining new functions.  Fortran and C
 code can be linked and called at run time.
 .
 S is the statistician's Matlab and R is to S what Octave is to Matlab.

Package: r-gnome
Architecture: any
Depends: r-base (= ${Source-Version}), ${shlibs:Depends}
Description: `GNU S' - GNOME-enabled executable
 R is described by its authors as "not unlike" S, which is a language
 developed at Bell Laboratories for statistical computing and graphics.
 It provides support for a variety of statistical and graphical analyses.
 R is a true computer language which contains a number of control-flow
 constructions for iteration and alternation.  It allows users to add
 additional functionality by defining new functions.  Fortran and C
 code can be linked and called at run time.
 .
 This package provides the executable linked with the GNOME libraries
 for use as in "R --gui=GNOME"

Package: r-doc-pdf
Architecture: all
Section: doc
Suggests: r-base, xpdf | acroread | pdf-viewer
Description: `GNU S' documentation in pdf format
 R is described by its authors as "not unlike" S, which is a language
 developed at Bell Laboratories for statistical computing and graphics.
 It provides support for a variety of statistical and graphical analyses.
 R is a true computer language which contains a number of control-flow
 constructions for iteration and alternation.  It allows users to add
 additional functionality by defining new functions.  Fortran and C
 code can be linked and called at run time.
 .
 This packages provides the R manuals in pdf format. The sibling package
 r-doc-html provides the same manuals in html format.

Package: r-doc-html
Architecture: all
Section: doc
Suggests: r-base, mozilla | konqueror | links | lynx | www-browser
Replaces: r-base
Description: `GNU S' documentation in html format
 R is described by its authors as "not unlike" S, which is a language
 developed at Bell Laboratories for statistical computing and graphics.
 It provides support for a variety of statistical and graphical analyses.
 R is a true computer language which contains a number of control-flow
 constructions for iteration and alternation.  It allows users to add
 additional functionality by defining new functions.  Fortran and C
 code can be linked and called at run time.
 .
 This packages provides the R manuals in html format. The sibling package
 r-doc-pdf provides the same manuals in pdf format.

Package: r-base-dev
Architecture: all
Depends: r-base, blas-dev (>= 1.0-9), build-essential, g77 | g77-3.0 | f2c, gcc | gcc-3.0, g++ | g++-3.0
Description: `GNU S'  - Allow installation of auxillary R packages
 R is described by its authors as "not unlike" S, which is a language
 developed at Bell Laboratories for statistical computing and graphics.
 It provides support for a variety of statistical and graphical analyses.
 R is a true computer language which contains a number of control-flow
 constructions for iteration and alternation.  It allows users to add
 additional functionality by defining new functions.  Fortran and C
 code can be linked and called at run time.
 .
 This packages ensures that other Debian packages needed for installation of
 some auxillary R packages are installed.

Package: r-mathlib
Architecture: any
Depends: r-base, r-base-dev
Description: `GNU S'  - Standalone R math library
 R is described by its authors as "not unlike" S, which is a language
 developed at Bell Laboratories for statistical computing and graphics.
 It provides support for a variety of statistical and graphical analyses.
 R is a true computer language which contains a number of control-flow
 constructions for iteration and alternation.  It allows users to add
 additional functionality by defining new functions.  Fortran and C
 code can be linked and called at run time.
 .
 This packages provides the libRmath shared and static libraries which can
 be called from standalone C or C++ code.

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules file for the Debian GNU/Linux r-base package
# Copyright 1997-2001 by Douglas Bates <bates@stat.wisc.edu>, <edd@debian.org>
# Copyright 2001      by Dirk Eddelbuettel <edd@debian.org>

# $Id: rules,v 1.36.2.1 2002/01/24 16:05:41 bates Exp $

package		= r-base
pdfpackage	= r-doc-pdf
htmlpackage	= r-doc-html
gnomepackage	= r-gnome
nmathpackage	= r-mathlib

# for the standalone library, no sonames are assigned in the upstream Makefiles
somaj		= 1
somin		= 0
sorel		= 0
libver		= $(somaj).$(somin).$(sorel)

debbase		:= $(CURDIR)/debian
debtmp		:= $(debbase)/tmp
debdoc		:= $(debbase)/$(package)/usr/share/doc/$(package)
debmat		:= $(debbase)/$(nmathpackage)

arch		:= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

# set this to 1 (default) if you want the Gnome GUI package
gnome		= 1
ifeq ($(gnome),0)
gnomeconfig 	= --without-gnome
else
gnomeconfig	= --with-gnome
endif

export DH_VERBOSE=
export DH_COMPAT=3

# edd 15 Aug 2001: default to blas, atlas can override it 
atlas = --with-blas=blas

# edd 02 Sep 2001: default to g77 but let m68k use f2c
fortran 	= --with-g77=/usr/bin/g77
compiler	= gcc
cxxcompiler	= g++

# edd 04 Sep 2001  default compiler flags, lowered for m68k
compilerflags	= -O2
# m68k barks when using g77, and when gcc use -O2
ifeq ($(arch),m68k-linux)
fortran		= --with-f2c
compilerflags	= -O
endif

## edd 09 Nov 2001  ia64 needs gcc-3.0, hppa gets it by default
ifeq ($(arch),ia64-linux)
fortran 	= --with-g77=/usr/bin/g77-3.0
compiler	= gcc-3.0
cxxcompiler	= g++-3.0
compilerflags	= -O2
endif

## lamont@debian.org 06 Dec 2001  hppa needs -ffunction-sections  
ifeq ($(arch),hppa-linux)
compilerflags   = -O2 -ffunction-sections
endif


## try gcc-3.0 on i386 -- appears to work
#ifeq ($(arch),i386-linux)
#fortran 	= --with-g77=/usr/bin/g77-3.0
#compiler	= gcc-3.0
#cxxcompiler	= g++-3.0
#compilerflags	= -O2
#endif

get-orig-source: upstream
upstream:
	links http://cran.us.r-project.org

build: configure make-arch build-arch build-stamp
build-stamp: 
	touch build-stamp

build-arch: configure make-arch build-arch-stamp
build-arch-stamp:
	touch build-arch-stamp

configure: configure-stamp
configure-stamp:	
	dh_testdir
	R_UNZIPCMD=/usr/bin/miniunzip 			\
	R_ZIPCMD=/usr/bin/minizip 			\
	CC=${compiler} 					\
	CXX=${cxxcompiler} 				\
	CPPFLAGS= LIBS=	FLIBS=-lg2c-pic			\
	./configure --prefix=/usr		     \
		    --with-tcltk		     \
		    --with-tcl-config=/usr/lib/tcl8.3/tclConfig.sh 	\
		    --with-tk-config=/usr/lib/tk8.3/tkConfig.sh 	\
		    --mandir=$(debtmp)/usr/share/man \
		    $(fortran)			     \
		    $(atlas)                         \
		    $(gnomeconfig)		     \
		    --enable-R-profiling             \
		    --enable-R-shlib                 \
		    --host $(arch)
        ## hppa and ia64 really need the PIC version of libg2c
        ## for conformity we will use it throughout
	perl -p -i -e "s/ -lg2c / -lg2c-pic /" Makeconf
        ## same needed for lower-level library files
	for i in ctest modreg mva ts; do 			\
		perl -p -i -e "s/ -lg2c / -lg2c-pic /" 		\
				src/library/$$i/src/Makefile; 	\
	done
        ## and etc/Makeconf	
	perl -p -i -e "s/ -lg2c / -lg2c-pic /" etc/Makeconf
	touch configure-stamp

make-arch: configure make-arch-stamp 
make-arch-stamp: 
	make		CFLAGS="$(compilerflags)"		\
			CXXFLAGS="$(compilerflags)"		\
			FFLAGS="$(compilerflags)"		\
			CC=${compiler} 				\
			CXX=${cxxcompiler}
	(cd src/nmath/standalone; 				\
		make	CFLAGS="$(compilerflags) -D_REENTRANT"	\
			CXXFLAGS="$(compilerflags) -D_REENTRANT"\
			FFLAGS="$(compilerflags) -D_REENTRANT"	\
			CC=${compiler} 				\
			CXX=${cxxcompiler} 			\
			libRmath_la_LDFLAGS=-Wl,-soname,libRmath.so.$(somaj) )
	make help
	make info 
	touch make-arch-stamp

make: configure make-arch make-stamp
make-stamp: 
        # Already made in general 'make': make html
	make pdf
	touch make-stamp

check: configure make-arch check-stamp
check-stamp: 
ifneq	($(arch),arm-linux)
	make check
endif
	touch check-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp make-stamp make-arch-stamp \
		install-stamp install-arch-stamp check-stamp build-arch-stamp
	-make distclean
	-rm -f `find . -name "*~"`
	-rm -rf debian/tmp debian/files* core debian/substvars
	-rm -f doc/html/function.html doc/html/packages.html
	-rm -f modules/*.so
	dh_clean

install-arch: make-arch check install-arch-stamp
install-arch-stamp: 
	dh_testdir
	dh_testroot
	dh_clean -a -k
	dh_installdirs -A
	make    	prefix=$(debtmp)/usr   	 	install

        # set R_HOME_DIR env.var. in R shell script
	sed -e '/^R_HOME_DIR=.*/s::R_HOME_DIR=/usr/lib/R:' \
	  < bin/R > $(debtmp)/usr/bin/R
	sed -e '/^R_HOME_DIR=.*/s::R_HOME_DIR=/usr/lib/R:' \
	  < bin/R > $(debtmp)/usr/lib/R/bin/R

        # fix permissions (Lintian)
	chmod a+x 	$(debtmp)/usr/lib/R/share/sh/echo.sh \
			$(debtmp)/usr/lib/R/share/sh/help-links.sh

        # remove unneeded license files, but link them back
	rm -v 	$(debtmp)/usr/lib/R/COPYING 		\
		$(debtmp)/usr/lib/R/COPYING.LIB 
	(cd $(debtmp)/usr/lib/R/; \
		ln -s ../../share/common-licenses/GPL COPYING; \
		ln -s ../../share/common-licenses/LGPL COPYING.LIB)

        # move the GNOME version to the r-gnome package
ifneq ($(gnome),0)
	dh_movefiles	-p$(gnomepackage) 	usr/lib/R/modules/R_gnome.so
endif

        # move the html manual files in r-doc-html.files into r-doc-html 
        # these get built in make-arch too ...
	dh_movefiles	-p$(htmlpackage)		

        # move files for r-base
	dh_movefiles	-p$(package)

        # for the standalone library package, move the two libs
        # as 'make install' ignore these, we have to do it by hand
	dh_installdirs -p$(nmathpackage) usr/include usr/lib
	install -m 0644 src/nmath/standalone/libRmath.a     \
			$(debmat)/usr/lib
	install -m 0644 src/nmath/standalone/libRmath.so    \
			$(debmat)//usr/lib/libRmath.so.$(libver)
	(cd $(debmat)/usr/lib; \
			ln -s libRmath.so.$(libver) libRmath.so.$(somaj))
        # and create a link for Rmath.h 
	(cd $(debmat)/usr/include; \
			ln -s ../lib/R/include/Rmath.h .)
	touch install-arch-stamp

install: make-arch make install-arch install-stamp
install-stamp: 
	dh_testdir
	dh_testroot
	dh_clean -a -k
	dh_installdirs -A
	make    	prefix=$(debtmp)/usr   	 	install-pdf	
        # move the pdf manual files listed in r-doc-pdf.files into r-doc-pdf 
	dh_movefiles	-p$(pdfpackage)		
        # move the html manual files in r-doc-html.files into r-doc-html 
	dh_movefiles	-p$(htmlpackage)		
	touch install-stamp

# Build architecture-independent files here.
binary-indep: build install
	dh_testdir -i
	dh_testroot -i
	dh_link -i
#	dh_installdebconf -i
	dh_installdocs -i
#	dh_installexamples -i
#	dh_installmenu -i
#	dh_installemacsen -i
#	dh_installpam -i
#	dh_installmime -i
#	dh_installinit -i
#	dh_installcron -i
#	dh_installmanpages -i
#	dh_installinfo -i
#	dh_undocumented -i
	dh_installchangelogs -i	
	dh_compress -i
	dh_fixperms -i
#	dh_suidregister -i
	dh_installdeb -i
#	dh_perl -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

# Build architecture-dependent files here.
binary-arch: build-arch install-arch check
	dh_testdir -a
	dh_testroot -a
#	dh_installdebconf -a
	dh_link -a
	dh_installdocs -p$(package) 	AUTHORS BUGS COPYRIGHTS FAQ 	\
					NEWS ONEWS README RESOURCES 	\
					THANKS Y2K debian/README.Atlas
	dh_installexamples -a
	dh_installmenu -a
#	dh_installemacsen -a
#	dh_installpam -a
#	dh_installmime -a
#	dh_installinit -a
#	dh_installcron -a
#	dh_installmanpages -a	-N$(gnomepackage) -p$(package) getline.3
#	dh_installman 		-p$(package) doc/R.1
	dh_installinfo -a	-n doc/manual/R-*.info*
	(cd $(debdoc)/doc && ln -s ../../../../lib/R/doc/html .)
	(cd $(debdoc)/doc && ln -s ../../../../lib/R/doc/manual .)
	(cd $(debdoc) && ln -s ../../../lib/R/library .)
        # install lintian "silencer"
	install -p -m 0644  debian/$(package).lintian \
		$(debbase)/$(package)/usr/share/lintian/overrides/$(package)
#	dh_undocumented -a
	dh_installchangelogs -a	-k NEWS 
	dh_strip -a
	dh_compress -a
